/*
birdtitle.js
Titles the titlebar as configured
Written for Songbird 0.3.X/0.4/0.5
Last updated on 01.07.2008 by compugeek32
*/

var birdtitle= {
	isVideoWin:false,
	isMainWin:true,
	notAPlaylist:true,
	origtitle: document.getElementsByTagName("window")[0].getAttribute("title"),
	pb: Components.classes["@mozilla.org/preferences;1"].createInstance(Components.interfaces.nsIPrefBranch),
	cp_artist: SB_NewDataRemote( "metadata.artist", null ),
	cp_title: SB_NewDataRemote( "metadata.title", null ),
	cp_album: SB_NewDataRemote( "metadata.album", null ),
	cp_genre: SB_NewDataRemote( "metadata.genre", null ),
	cp_pos: SB_NewDataRemote( "metadata.position.str", null ),
	cp_len: SB_NewDataRemote( "metadata.length.str", null ),
	cp_playing: SB_NewDataRemote( "faceplate.playing",null ),
	cp_paused: SB_NewDataRemote( "faceplate.paused",null ),
	isPlayingVideo: SB_NewDataRemote("faceplate.playingvideo",null),
	sb_meta: "songbird.metadata.",
	prefpre: "birdtitle.",
	currBrowserTitle: "",
	strposat: 0,
	intervScrFunc: null,
	scrInt: 0,
	currTtlLength: 0,
	currWinState: 3,
	playingText: "",
	pausedText: "",
	stoppedText: "",
	sbbuildID:"",
	origtitle2:"",
	isPlayingVideo2:{
		observe:function(subject,topic,data){
			if(data=="0"){
				birdtitle.config.isPlayingVideo=false;
			}else{
				birdtitle.config.isPlayingVideo=true;
			}
			birdtitle.doScroll();
		}
	},config: {
		titleType: null,
		title: null,
		tb_useTitle: null,
		tb_title: null,
		min_useTitle: null,
		min_title: null,
		dispPlayStat: null,
		dispPausedStat: null,
		dispStoppedStat: null,
		scr_tb: null,
		scr_int: null,
		ui_enableTitleRightClick: null,
		playingText: null,
		pausedText: null,
		stoppedText: null,
		outputPlaylistNameAsTitle: null,
		isPlayingVideo: null,
		scrVidTitleOnly:null
	},chgTitle: function(){
		var titlebar=document.getElementsByTagName("sb-sys-titlebar")[0];
		pref_title= birdtitle.config.title;
		if( window.windowState == STATE_MINIMIZED && birdtitle.config.min_useTitle ) {
			document.title=birdtitle.processTitle( birdtitle.config.min_title, true);
		} else {
			if(titlebar!=null) switch( birdtitle.config.titleType ){
				case 0:
					if(birdtitle.config.allowTitleCharLimit) titlebar.setAttribute( "value", birdtitle.processTitle( birdtitle.config.tb_title, false ).substr(0,birdtitle.config.titleCharLimit));
					else titlebar.setAttribute( "value", birdtitle.processTitle( birdtitle.config.tb_title, false ));
				break;
				case 1:
					titlebar.setAttribute("value",birdtitle.processTitle(birdtitle.origtitle,false));
				break;
				case 2:
					if(birdtitle.config.allowTitleCharLimit) titlebar.setAttribute("value",(birdtitle.processTitle(pref_title,false)).substr(0,birdtitle.config.titleCharLimit));
					else titlebar.setAttribute("value",birdtitle.processTitle(pref_title,false));
				break;
			}if(birdtitle.config.tb_useTitle){
				if(birdtitle.config.tb_allowTitleCharLimit) document.title=(birdtitle.processTitle(birdtitle.config.tb_title,true)).substr(0,birdtitle.config.tb_titleCharLimit);
				else document.title=birdtitle.processTitle(birdtitle.config.tb_title,true);
			}else{

			}
		}
	},processTitle: function(thetext, canScroll){
		var thetext2=(((((((((thetext.replace(/\$buildid\$/,birdtitle_2.buildNum)).replace(/\$deftitle\$/,birdtitle.origtitle)).replace(/\$title\$/,birdtitle.cp_title.stringValue)).replace(/\$artist\$/,birdtitle.cp_artist.stringValue)).replace(/\$album\$/,birdtitle.cp_album.stringValue)).replace(/\$genre\$/,birdtitle.cp_genre.stringValue)).replace(/\$pos\$/,birdtitle.cp_pos.stringValue)).replace(/\$len\$/,birdtitle.cp_len.stringValue)).replace(/\$status\$/,birdtitle_2.getTrackStatus())).replace(/\$wptitle\$/,birdtitle.currBrowserTitle);
		birdtitle.currTtlLength=thetext2.length;
		if(birdtitle.intervScrFunc!=null&&canScroll){
			var aab=thetext2.substring(0,birdtitle.strposat);
			var aac=thetext2.substring(birdtitle.strposat-1,birdtitle.currTtlLength);
			return aac+" "+aab;
		}else{
			return thetext2;
		}
	},init2: function(){
		//This function gets called by init() in common.js
		var wb=getBrowser();
		try{
			//Does this listener already exist??
			wb.removeEventListener("DOMTitleChanged",function(a){if(a.currentTarget==wb) birdtitle.updtitle(a.currentTarget)},true);
		}catch(e){
		}
		wb.addEventListener("DOMTitleChanged",function(a){if(a.currentTarget==wb) birdtitle.updtitle(a.currentTarget)},true);
		wb.tabContainer.addEventListener("select",function(){birdtitle.updtitle(wb)},true);
		birdtitle.config.titleType=birdtitle.pb.getIntPref(birdtitle.prefpre+"titleType");
		birdtitle.config.title=birdtitle.pb.getCharPref(birdtitle.prefpre+"title");
		birdtitle.config.tb_useTitle=birdtitle.pb.getBoolPref(birdtitle.prefpre+"taskbar.useTitle");
		birdtitle.config.tb_title=birdtitle.pb.getCharPref(birdtitle.prefpre+"taskbar.title");
		birdtitle.config.dispPlayStat=birdtitle.pb.getBoolPref(birdtitle.prefpre+"displayPlayingStatus");
		birdtitle.config.dispPausedStat=birdtitle.pb.getBoolPref(birdtitle.prefpre+"displayPausedStatus");
		birdtitle.config.dispStoppedStat=birdtitle.pb.getBoolPref(birdtitle.prefpre+"displayStoppedStatus");
		birdtitle.config.scr_tb=birdtitle.pb.getBoolPref(birdtitle.prefpre+"ui.scrollOnTaskbar");
		birdtitle.config.scr_int=birdtitle.pb.getIntPref(birdtitle.prefpre+"ui.scrollInterval");
		birdtitle.config.playingText=birdtitle.pb.getCharPref(birdtitle.prefpre+"playText");
		birdtitle.config.pausedText=birdtitle.pb.getCharPref(birdtitle.prefpre+"pausedText");
		birdtitle.config.stoppedText=birdtitle.pb.getCharPref(birdtitle.prefpre+"stoppedText");
		birdtitle.config.titleCharLimit=birdtitle.pb.getIntPref(birdtitle.prefpre+"maxcharacters");
		birdtitle.config.allowTitleCharLimit=birdtitle.pb.getBoolPref(birdtitle.prefpre+"displayMaxChars");
		birdtitle.config.min_useTitle=birdtitle.pb.getBoolPref(birdtitle.prefpre+"minimized.useTitle");
		birdtitle.config.min_title=birdtitle.pb.getCharPref(birdtitle.prefpre+"minimized.title");
		birdtitle.config.outputPlaylistNameAsTitle=birdtitle.pb.getBoolPref(birdtitle.prefpre+"outputPlaylistNameAsTitle");
		birdtitle.config.scrVidTitleOnly=birdtitle.pb.getBoolPref(birdtitle.prefpre+"videowin.ui.scrollOnTaskbarOnly");
		birdtitle.doScroll();
		if (!birdtitle.config.tb_useTitle){
			try{
				wb.contentDocument.title=wb.contentTitle;
			}catch(e){
				//Why??
			}
		}else{
			birdtitle.updtitle(wb);
		}
	},updtitle: function(a){
		if((a.contentDocument.documentURI).indexOf("chrome://songbird/content/xul/sbLibraryPage.xul")!=-1&&birdtitle.config.outputPlaylistNameAsTitle){
			var ct=a.tabContainer.selectedItem;
			var pl1=ct.getPlaylist();
			if(pl1.displayName==undefined||pl1.displayName==""){
				a.contentWindow.addEventListener("load",function(){
					birdtitle.currBrowserTitle=pl1.displayName;
					if(ct==a.tabContainer.selectedItem)	birdtitle.chgTitle();
				},false);
			}else{
				birdtitle.currBrowserTitle=pl1.displayName;		
				birdtitle.chgTitle();
			}
		}else{
			birdtitle.currBrowserTitle=a.contentTitle;
			birdtitle.chgTitle();
		}
	},doScroll: function(){
		if(birdtitle.config.scr_tb&&(!birdtitle.config.isPlayingVideo||(birdtitle.config.isPlayingVideo&&!birdtitle.config.scrVidTitleOnly))){
			if(birdtitle.intervScrFunc==null||birdtitle.scrInt!=birdtitle.config.scr_int){
				window.clearTimeout(birdtitle.intervScrFunc);
				birdtitle.intervScrFunc=null;
				birdtitle.scrInt=birdtitle.config.scr_int;
				if (birdtitle.config.tb_useTitle) birdtitle.intervScrFunc=window.setInterval("birdtitle_2.scrollOnTaskbar()",birdtitle.scrInt);
			}
		}else{
			if(birdtitle.intervScrFunc!=null){
				window.clearTimeout(birdtitle.intervScrFunc);
				birdtitle.intervScrFunc=null;
			}
		}
	}
};