/*
Birdtitle.js
Maintains program title as configured
Written for Songbird 0.3/0.4
Last updated on 11.17.2007 by compugeek32
*/

var birdtitle= {
	isVideoWin:false,
	isMainWin:false,
	isMiniPlayer:true,
	origtitle:window.title,
	pb: Components.classes["@mozilla.org/preferences;1"].createInstance(Components.interfaces.nsIPrefBranch),
	cp_artist: SB_NewDataRemote( "metadata.artist", null ),
	cp_title: SB_NewDataRemote( "metadata.title", null ),
	cp_album: SB_NewDataRemote( "metadata.album", null ),
	cp_genre: SB_NewDataRemote( "metadata.genre", null ),
	cp_pos: SB_NewDataRemote( "metadata.position.str", null ),
	cp_len: SB_NewDataRemote( "metadata.length.str", null ),
	cp_playing: SB_NewDataRemote( "faceplate.playing",null ),
	cp_paused: SB_NewDataRemote( "faceplate.paused",null ),
	sb_meta: "songbird.metadata.",
	prefpre: "birdtitle.",
	prefpre2: "birdtitle.miniplayer.",
	isPlayingVideo: SB_NewDataRemote("faceplate.playingvideo",null),
	strposat: 0,
	intervScrFunc: null,
	scrInt: 0,
	currTtlLength: 0,
	playingText: "",
	pausedText: "",
	stoppedText: "",
	sbbuildID:"",
	origtitle2:"",
	isPlayingVideo2:{
		observe:function(subject,topic,data){
			if(data=="0"){
				birdtitle.config.isPlayingVideo=false;
			}else{
				birdtitle.config.isPlayingVideo=true;
			}
			birdtitle.doScroll();
		}
	},
	config: {
		tb_useTitle: null,
		tb_title: null,
		dispPlayStat: null,
		dispPausedStat: null,
		dispStoppedStat: null,
		scr_tb: null,
		scr_int: null,
		playingText: null,
		pausedText: null,
		stoppedText: null,
		isPlayingVideo: null,
		scrVidTitleOnly:null
	},chgTitle: function(){
		pref_title=birdtitle.config.title;
		if(birdtitle.config.tb_useTitle){
			if(birdtitle.config.tb_allowTitleCharLimit) document.title=(birdtitle.processTitle(birdtitle.config.tb_title,true)).substr(0,birdtitle.config.tb_titleCharLimit);
			else document.title=birdtitle.processTitle(birdtitle.config.tb_title,true);
		}else{

		}
	},processTitle: function(thetext, canScroll){
		var thetext2=((((((((thetext.replace(/\$buildid\$/,birdtitle_2.buildNum)).replace(/\$deftitle\$/,birdtitle.origtitle)).replace(/\$title\$/,birdtitle.cp_title.stringValue)).replace(/\$artist\$/,birdtitle.cp_artist.stringValue)).replace(/\$album\$/,birdtitle.cp_album.stringValue)).replace(/\$genre\$/,birdtitle.cp_genre.stringValue)).replace(/\$pos\$/,birdtitle.cp_pos.stringValue)).replace(/\$len\$/,birdtitle.cp_len.stringValue)).replace(/\$status\$/,birdtitle_2.getTrackStatus());
		birdtitle.currTtlLength=thetext2.length;
		if(birdtitle.intervScrFunc!=null&&canScroll){
			var aab=thetext2.substring(0,birdtitle.strposat);
			var aac=thetext2.substring(birdtitle.strposat-1,birdtitle.currTtlLength);
			return aac+" "+aab;
		}else{
			return thetext2;
		}
	},init2: function(){
		//This function gets called by init() in common.js
		birdtitle.config.tb_useTitle=birdtitle.pb.getBoolPref(birdtitle.prefpre2+"taskbar.useTitle");
		//alert(1);
		birdtitle.config.tb_title=birdtitle.pb.getCharPref(birdtitle.prefpre2+"taskbar.title");
		birdtitle.config.dispPlayStat=birdtitle.pb.getBoolPref(birdtitle.prefpre+"displayPlayingStatus");
		birdtitle.config.dispPausedStat=birdtitle.pb.getBoolPref(birdtitle.prefpre+"displayPausedStatus");
		birdtitle.config.dispStoppedStat=birdtitle.pb.getBoolPref(birdtitle.prefpre+"displayStoppedStatus");
		birdtitle.config.scr_tb=birdtitle.pb.getBoolPref(birdtitle.prefpre2+"ui.scrollOnTaskbar");
		birdtitle.config.scr_int=birdtitle.pb.getIntPref(birdtitle.prefpre+"ui.scrollInterval");
		birdtitle.config.playingText=birdtitle.pb.getCharPref(birdtitle.prefpre+"playText");
		birdtitle.config.pausedText=birdtitle.pb.getCharPref(birdtitle.prefpre+"pausedText");
		birdtitle.config.stoppedText=birdtitle.pb.getCharPref(birdtitle.prefpre+"stoppedText");
		birdtitle.config.scrVidTitleOnly=birdtitle.pb.getBoolPref(birdtitle.prefpre+"videowin.ui.scrollOnTaskbarOnly");
		birdtitle.doScroll();
	},doScroll: function(){
		if(birdtitle.config.scr_tb&&(!birdtitle.config.isPlayingVideo||(birdtitle.config.isPlayingVideo&&!birdtitle.config.scrVidTitleOnly))){
			if(birdtitle.intervScrFunc==null||birdtitle.scrInt!=birdtitle.config.scr_int){
				window.clearTimeout(birdtitle.intervScrFunc);
				birdtitle.intervScrFunc=null;
				birdtitle.scrInt=birdtitle.config.scr_int;
				if (birdtitle.config.tb_useTitle) birdtitle.intervScrFunc=window.setInterval("birdtitle_2.scrollOnTaskbar()",birdtitle.scrInt);
			}
		}else{
			if(birdtitle.intervScrFunc!=null){
				window.clearTimeout(birdtitle.intervScrFunc);
				birdtitle.intervScrFunc=null;
			}
		}
	}
};
