/*
common.js
Contains common methods invoked by birdtitle.js, birdtitle_mp.js,
and birdtitle_videowin.js
Written for Songbird 0.3/0.4
Last updated on 11.19.2007 by compugeek32
*/

var birdtitle_2={
	appInfo:Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo),
	cp_artist: SB_NewDataRemote( "metadata.artist", null ),
	cp_title: SB_NewDataRemote( "metadata.title", null ),
	cp_album: SB_NewDataRemote( "metadata.album", null ),
	cp_genre: SB_NewDataRemote( "metadata.genre", null ),
	cp_pos: SB_NewDataRemote( "metadata.position.str", null ),
	cp_len: SB_NewDataRemote( "metadata.length.str", null ),
	cp_playing: SB_NewDataRemote( "faceplate.playing",null ),
	cp_paused: SB_NewDataRemote( "faceplate.paused",null ),
	metadata: {
		artist: {
			observe: function(){
				birdtitle.chgTitle();
			}
		},title: {
			observe: function(){
				birdtitle.chgTitle();
			}
		},album: {
			observe: function(){
				birdtitle.chgTitle();
			}
		},genre: {
			observe: function(){
				birdtitle.chgTitle();
			}
		},pos: {
			observe: function(){
				birdtitle.chgTitle();
			}
		},len: {
			observe: function(){
				birdtitle.chgTitle();
			}
		},status: {
			observe: function(subject, topic, data){
				birdtitle.chgTitle();
			}
		}
	},getTrackStatus: function(){
		var cp_playing=birdtitle_2.cp_playing;
		var cp_paused=birdtitle_2.cp_paused;
		if(cp_playing.stringValue=="1"&&cp_paused.stringValue=="0"&&birdtitle.config.dispPlayStat){
			return birdtitle.config.playingText;
		}else if(cp_playing.stringValue=="1"&&cp_paused.stringValue=="1"&&birdtitle.config.dispPausedStat){
			return birdtitle.config.pausedText;
		}else if(cp_playing.stringValue=="0"&&cp_paused.stringValue=="0"&&birdtitle.config.dispStoppedStat){
			return birdtitle.config.stoppedText;
		}else{
			return "";
		}
	},viewOptions: function(){
		window.openDialog("chrome://birdtitle/content/options.xul","ABWPPrefsDialog","chrome,centerscreen,dialog,modal");
		birdtitle.chgTitle();
	},scrollOnTaskbar: function(){
		if(birdtitle.strposat>=birdtitle.currTtlLength){
			birdtitle.strposat=0;
		}else{
			birdtitle.strposat++;
		}birdtitle.chgTitle();
	},init: function(){
		birdtitle_2.buildNum=birdtitle_2.appInfo.appBuildID;
		birdtitle_2.version=birdtitle_2.appInfo.version;
		birdtitle_2.os=birdtitle_2.appInfo.OS;
		if(!birdtitle.isVideoWin){
			birdtitle_2.cp_artist.bindObserver(birdtitle_2.metadata.artist,true);
			birdtitle_2.cp_title.bindObserver(birdtitle_2.metadata.title,true);
			birdtitle_2.cp_album.bindObserver(birdtitle_2.metadata.album,true);
			birdtitle_2.cp_genre.bindObserver(birdtitle_2.metadata.genre,true);
			birdtitle_2.cp_pos.bindObserver(birdtitle_2.metadata.pos,true);
			birdtitle_2.cp_len.bindObserver(birdtitle_2.metadata.len,true);
			birdtitle_2.cp_playing.bindObserver(birdtitle_2.metadata.status,true);
			birdtitle_2.cp_paused.bindObserver(birdtitle_2.metadata.status,true);
		}if(birdtitle.isMainWin||birdtitle.isMiniPlayer){
			birdtitle.isPlayingVideo.bindObserver(birdtitle.isPlayingVideo2,true);
		}
		birdtitle.init2();
	},unbinddataremotes: function(){
		birdtitle_2.cp_artist.unbind();
		birdtitle_2.cp_title.unbind();
		birdtitle_2.cp_album.unbind();
		birdtitle_2.cp_genre.unbind();
		birdtitle_2.cp_pos.unbind();
		birdtitle_2.cp_len.unbind();
		birdtitle_2.cp_playing.unbind();
		birdtitle_2.cp_paused.unbind();
	}
};
	window.addEventListener("unload",birdtitle_2.unbinddataremotes,false);
	window.addEventListener("blur",function(){
		if(window.windowState == STATE_MINIMIZED){
			birdtitle.chgTitle();
		}},true);
	window.addEventListener("focus",function(){birdtitle.chgTitle()},true);
	window.addEventListener("load",function(){birdtitle_2.init()},false);