// Do some slick handling of JS functionality.  Set event handlers, etc.

// Want to know if someone asked an item in a playlist to be played?
function PausePlayStop_onPlaylistPlay( aEvent ) { // <-- tag your function names with your extension's name to avoid namespace collisions!!!
  var playlist = aEvent.originalTarget;
  var number = "unknown";
  try {
    // Events from the "inner" playlist will be wrapped
    while ( playlist.wrappedJSObject )
      playlist = playlist.wrappedJSObject;
      
    // Once we have a "real" playlist, we can ask for things like length
    number = playlist.mediaListView.length;
  } catch(e) {}
  
  // And then display our findings here.
//  alert( playlist.nodeName + " has " + number + " item(s)" );
}

// Unload our listeners!  ALWAYS!!!
function PausePlayStop_onUnload( aEvent ) {
  window.removeEventListener( "unload", PausePlayStop_onUnload, false );
  document.removeEventListener( "playlist-play", PausePlayStop_onPlaylistPlay, true );
}

// ALWAYS listen for the window.unload event to be able to remove our listeners.
window.addEventListener( "unload", PausePlayStop_onUnload, false );

// Listen for the "playlist-play" event to know when a user has started playback from the playlist.
document.addEventListener( "playlist-play", PausePlayStop_onPlaylistPlay, true );
