

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Component;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.RenderingHints;
import java.awt.Stroke;
import java.awt.geom.Ellipse2D;
import java.awt.geom.RoundRectangle2D;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.UIManager;
import javax.swing.plaf.metal.MetalSliderUI;
import java.awt.RadialGradientPaint;

public class AlbumSliderUI extends MetalSliderUI {
    
    private static final Icon GHOST_THUMB_ICON = new GhostThumbIcon();

    @Override
    public void installUI(JComponent c) {
        UIManager.put("Slider.verticalThumbIcon", GHOST_THUMB_ICON);
        UIManager.put("Slider.horizontalThumbIcon", GHOST_THUMB_ICON);
        super.installUI(c);
        c.setOpaque(false);
    }
    
    @Override
    public void paintTrack(Graphics g)  {
        Graphics2D g2 = (Graphics2D) g;
        
//        BufferedImage image = new BufferedImage(slider.getWidth(), slider.getHeight(), BufferedImage.TYPE_INT_ARGB);
//        Graphics2D g2 = (Graphics2D) image.createGraphics();

        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
        
        
        int height =  trackRect.height;//+ width / 2;
		int width = trackRect.width + height / 2;
		
        
        
         
        g2.translate(trackRect.x - height/4, trackRect.y  );
       
        RoundRectangle2D casing = new RoundRectangle2D.Double(0, 0, width, height, 27, 27);
        g2.setColor(new Color(0x505050));
        
        Composite composite = g2.getComposite();
        g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.5f));
        g2.fill(casing);
        g2.setComposite(composite);

        Stroke stroke = g2.getStroke();
        g2.setStroke(new BasicStroke(1.0f));
        g2.draw(casing);
        g2.setStroke(stroke);
        
        g2.translate(-trackRect.x + height/4 , -trackRect.y );
        
//        g2.dispose();
//        try {
//            ImageIO.write(image, "PNG", new File("D:\\slider.png"));
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
    }

    private static final class GhostThumbIcon implements Icon {
        @Override
        public void paintIcon(Component c, Graphics g, int x, int y) {
            Graphics2D g2 = (Graphics2D) g;
            
            Ellipse2D thumb = new Ellipse2D.Double(1, 2, 17, 17);

            g2.setColor(new Color(0x101010));
                        
            Paint paint = g2.getPaint();
            //g2.setPaint(new GradientPaint(0, 10, new Color(0x000000), 0, 17, new Color(0xf0f0f0), true));
            g2.setPaint(new RadialGradientPaint(19/2, 24/2, 17/2, new float[] {0.0f, 1.0f}, new Color[] {Color.WHITE, new Color(0x202020)}));
            g2.fill(thumb);
            g2.setPaint(paint);
            
            Composite composite = g2.getComposite();
            g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.5f));
            g2.fill(thumb);
            g2.setComposite(composite);

           /*
            Stroke stroke = g2.getStroke();
            g2.setStroke(new BasicStroke(1.0f));
            g2.draw(thumb);
            g2.setStroke(stroke);
            */
        }

        @Override
        public int getIconWidth() {
            return 20;
        }

        @Override
        public int getIconHeight() {
            return 20;
        }
    }
}
